--------------------------------------------------------------------
-- Tooltips
--------------------------------------------------------------------


---------------------------
-- create tooltip
---------------------------
function Glance.Functions.setTT(owner)
	GameTooltip:ClearLines()
	GameTooltip:SetOwner(owner, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", owner, "BOTTOMLEFT", 0, -5)
	if owner == Glance.Buttons.Emblems then Glance.Functions.setTTEmblems()
	elseif owner == Glance.Buttons.Gold then Glance.Functions.setTTGold() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTGold()") end
	elseif owner == Glance.Buttons.Friends then Glance.Functions.setTTFriends() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTFriends()") end
	elseif owner == Glance.Buttons.Guild then Glance.Functions.setTTGuild() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTGuild()") end
	elseif owner == Glance.Buttons.Armor then Glance.Functions.setTTArmor() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTArmor()") end
	elseif owner == Glance.Buttons.XP then Glance.Functions.setTTXP() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTXP()") end
	elseif owner == Glance.Buttons.Rep then Glance.Functions.setTTRep() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTRep()") end
	elseif owner == Glance.Buttons.Lag then Glance.Functions.setTTLAG() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTLAG()") end
	elseif owner == Glance.Buttons.FPS then Glance.Functions.setTTFPS() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTFPS()") end
	elseif owner == Glance.Buttons.Mem then Glance.Functions.setTTMem() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTMem()") end
	elseif owner == Glance.Buttons.Mounts then Glance.Functions.setTTMounts() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTMounts()") end
	elseif owner == Glance.Buttons.Pets then Glance.Functions.setTTPets() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTPets()") end
	elseif owner == Glance.Buttons.WG then Glance.Functions.setTTWG() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTWG()") end
	elseif owner == Glance.Buttons.TB then Glance.Functions.setTTTB() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTTB()") end
	elseif owner == Glance.Buttons.Time then Glance.Functions.setTTTime() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTTime()") end
	elseif owner == Glance.Buttons.Professions then Glance.Functions.setTTProfessions() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTProfessions()") end
	end
	GameTooltip:Show()
end

---------------------------
-- tooltip text
---------------------------
function Glance.Functions.TTST(text,color)
	GameTooltip:SetText(text, Glance.Arrays.colors[color][1], Glance.Arrays.colors[color][2], Glance.Arrays.colors[color][3])
end
function Glance.Functions.TTAL(text,color)
	GameTooltip:AddLine(text, Glance.Arrays.colors[color][1], Glance.Arrays.colors[color][2], Glance.Arrays.colors[color][3])
end
function Glance.Functions.TTALW(text,color)
	GameTooltip:AddLine(text, Glance.Arrays.colors[color][1], Glance.Arrays.colors[color][2], Glance.Arrays.colors[color][3], 1)
end
function Glance.Functions.TTAD(text1,text2,col1,col2)
	GameTooltip:AddDoubleLine(text1, text2, Glance.Arrays.colors[col1][1], Glance.Arrays.colors[col1][2], Glance.Arrays.colors[col1][3], Glance.Arrays.colors[col2][1], Glance.Arrays.colors[col2][2], Glance.Arrays.colors[col2][3])
end

---------------------------
-- hide tooltip
---------------------------
function Glance.Functions.hideTooltip(self)
	GameTooltip:Hide()
end

---------------------------
-- Gold tooltip
---------------------------
function Glance.Functions.setTTGold()
	local htotal, atotal, total = 0, 0, 0
	local h,a,b = false, false, false
	if #Glance_Global.HordeGold ~= 0 then
		h = true
	end
	if #Glance_Global.AllianceGold ~= 0 then
		a = true
	end
	if h and a then
		b = true
	end
	Glance.Functions.TTST("Gold in Account","GLD")
	if b or h then
		if b then 
			Glance.Functions.TTAL(" ","GLD")
			Glance.Functions.TTAL("Horde Gold","GLD") 
		end
		for i=1,#Glance_Global.HordeGold do
			local name,count = unpack(Glance_Global.HordeGold[i])
			Glance.Functions.TTAD(name,GetCoinTextureString(count,0),"WHT","WHT")
			htotal = htotal + count
			total = total + count
		end
		if b then Glance.Functions.TTAD("Horde Total",GetCoinTextureString(htotal,0),"GRN","WHT") end
	end
	if b or h then
		if b then 
			Glance.Functions.TTAL(" ","GLD")
			Glance.Functions.TTAL("Alliance Gold","GLD")
		end
		for i=1,#Glance_Global.AllianceGold do
			local name,count = unpack(Glance_Global.AllianceGold[i])
			Glance.Functions.TTAD(name,GetCoinTextureString(count,0),"WHT","WHT")
			atotal = atotal + count
			total = total + count
		end
		if b then Glance.Functions.TTAD("Alliance Total",GetCoinTextureString(atotal,0),"GRN","WHT") end
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAD("Total Gold",GetCoinTextureString(total,0),"GRN","WHT")
	local gsession, gpersec, gperhour = 0,0,0
	if Glance.Variables.gold ~=0 then
		Glance.Functions.TTAL(" ","GLD")
		Glance.Functions.TTAL("Session","GLD")
		gsession = GetMoney() - Glance.Variables.gold
		gpersec = gsession/Glance.Variables.gametime.session
		gperhour = math.ceil(gpersec*3600)
		Glance.Functions.TTAD("Gold This Session",GetCoinTextureString(gsession,0),"WHT","WHT")
		Glance.Functions.TTAD("Gold/Hour",GetCoinTextureString(gperhour,0),"WHT","WHT")
	end
	if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTGold()") end
end

---------------------------
-- Emblems tooltip
---------------------------
function Glance.Functions.setTTEmblems()
	local hasEmblems = false
	Glance.Functions.TTST("Emblems","GLD")
	for i=1, GetCurrencyListSize() do
		local name,_,_,_,_,count,_,icon,_ = GetCurrencyListInfo(i)
		Glance.Functions.TTAD(name,count,"WHT","GRN")
		hasEmblems = true
	end
	if not hasEmblems then
		Glance.Functions.TTAL("|rYou have no emblems","WHT")
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("(Click to open the Currency tab.)","WHT")
	if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTEmblems()") end
end

---------------------------
-- Friends tooltip
---------------------------
function Glance.Functions.setTTFriends()
	local _,numFriends = GetNumFriends()
	local _,bnFriends = BNGetNumFriends()
	local friends = numFriends + bnFriends
	Glance.Functions.TTAL(numFriends.." Friend(s) Online","GLD")
	for i = 0, GetNumFriends() do
		local name, level, class, area, connected, status, note = GetFriendInfo(i)
		if connected then
			Glance.Functions.TTAD(name.." ("..level.." "..class..")", area, string.upper(class), "WHT")
		end
	end
	Glance.Functions.TTAL(" ","WHT")
	Glance.Functions.TTAL(bnFriends.." BattleNet Friend(s) Online","GLD")
	for j = 1, BNGetNumFriends() do
		local presenceID, givenName, surname, _,_,_,isOnline = BNGetFriendInfo(j)
		local _,toonName,_,realmName,_,race,class,_,zoneName,level,_,_,_ = BNGetToonInfo(presenceID)
		if isOnline then
			Glance.Functions.TTAD(givenName.." "..surname, toonName.." ("..level.." "..race.." "..class..") "..zoneName, "WHT", string.upper(class))
		end
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("(Click to open the Friends tab.)","WHT")
end

---------------------------
-- Guild tooltip
---------------------------
function Glance.Functions.setTTGuild()
	if IsInGuild() then
		local total = GetNumGuildMembers(true)
		local onlineTotal = 0
		local offlineTotal = 0
		local guild = {}
		for i = 1, total do
			local name,_, _,level,class,zone,_,_,online,_,_ = GetGuildRosterInfo(i)
			if online then
				onlineTotal = onlineTotal + 1
				table.insert(guild, {name, level, class, zone})
			else
				offlineTotal = offlineTotal + 1
			end
		end
		Glance.Functions.TTST(onlineTotal.."/"..total.." Guild Member(s) Online", "GLD")
		table.sort(guild, function(a, b) return a[1] < b[1] end)
		for k, v in pairs(guild) do
			Glance.Functions.TTAD(v[1].." ("..v[2].." "..v[3]..")", v[4], string.upper(v[3]), "WHT")
		end
		wipe(guild)
	else
		Glance.Functions.TTST("Guild Member(s)", "GLD")
		Glance.Functions.TTAL("|rYou are not in a guild.", "WHT")
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("(Click to open the Guild tab.)","WHT")
end

---------------------------
-- Armor tooltip
---------------------------
function Glance.Functions.setTTArmor()
	Glance.Functions.TTST("Armor", "GLD")
	local TotalRepairCost = Glance.Functions.checkInventory()
	local itemLevel = GetAverageItemLevel()
	if TotalRepairCost > 0 then
		Glance.Functions.TTAL("The total cost to repair your armor is: "..GetCoinTextureString(TotalRepairCost,0), "WHT")
	else
		Glance.Functions.TTAL("Your armor is fully repaired.", "WHT")
	end
	Glance.Functions.TTAL("Your average item level is "..math.floor(itemLevel)..".", "WHT")
	local pty = Glance.Variables.party
	if pty.a.level ~= 0 then
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAL("Party", "GLD")
		Glance.Functions.TTAD(pty.a.name, "|"..pty.a.armor.."%", "WHT", "GRN")
		if pty.b.level ~= 0 then
			Glance.Functions.TTAD(pty.a.name, "|"..pty.b.armor.."%", "WHT", "GRN")
		end
		if pty.c.level ~= 0 then
			Glance.Functions.TTAD(pty.a.name, "|"..pty.c.armor.."%", "WHT", "GRN")
		end
		if pty.d.level ~= 0 then
			Glance.Functions.TTAD(pty.a.name, "|"..pty.d.armor.."%", "WHT", "GRN")
		end
	end
end

---------------------------
-- XP tooltip
---------------------------
function Glance.Functions.setTTXP()
	Glance.Functions.setXP()
	local gti = Glance.Variables.gametime
	local var = Glance.Variables.xp
	local pty = Glance.Variables.party
	
	if var.level < 85 then
		Glance.Functions.TTST("Experience", "GLD")
		Glance.Functions.TTAD("Total XP Required This Level ("..var.level.." to "..(var.level+1)..")", var.cap,"WHT", "GRN")
		Glance.Functions.TTAD("XP Gained This Level ", "("..var.currentPCT.."%) "..var.current, "WHT", "GRN")
		Glance.Functions.TTAD("XP Needed To Level ", "("..var.neededPCT.."%) "..var.needed,"WHT", "GRN")
		if var.rested > 0 then
			Glance.Functions.TTAD("Rested XP ", "("..var.restedPCT.."%) "..var.rested, "BLU", "GRN")
		else
			Glance.Functions.TTAD("Rested XP ", "("..var.restedPCT.."%) "..var.rested, "PPL", "RED")
		end
	end
	
	if var.level == 85 then
		Glance.Functions.TTST("Game Time", "GLD")
	else
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAL("Game Time", "GLD")
	end
	Glance.Functions.TTAD("Total Time Played", Glance.Functions.formatTime(gti.total), "WHT", "GRN")
	Glance.Functions.TTAD("Time Played This Level ", Glance.Functions.formatTime(gti.level), "WHT", "GRN")
	Glance.Functions.TTAD("Time Played This Session ", Glance.Functions.formatTime(gti.session), "WHT", "GRN")
	
	if var.level < 85 then
		if var.xperhour ~= 0 then
			Glance.Functions.TTAL(" ", "WHT")
			Glance.Functions.TTAL("Leveling Speed", "GLD")
			Glance.Functions.TTAD("XP/Hour ", var.xperhour, "WHT", "GRN")
			Glance.Functions.TTAD("Time To Level",  Glance.Functions.formatTime(var.leveltime), "WHT", "GRN")
		end
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAL("Leveling Stats", "GLD")
		Glance.Functions.TTAD("Kills To Level (avg "..var.kills.avg.." xp)", var.kills2level, "WHT", "GRN")
		Glance.Functions.TTAD("Quests To Level (avg "..var.quests.avg.." xp)", var.quests2level, "WHT", "GRN")
		Glance.Functions.TTAD("Gathers To Level (avg "..var.gathers.avg.." xp)", var.gathers2level, "WHT", "GRN")
	end
	
	if Glance.Variables.Debug then
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAL("currentxp - initxp + accumulatedxp = sessionxp", "GLD")
		Glance.Functions.TTAL(var.current.." - "..var.init.." + "..var.accumulated.." = "..var.session, "WHT")
		
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAL("sessionxp/sessiontime = xpersec", "GLD")
		Glance.Functions.TTAL(var.session.."/"..gti.session.." = "..var.xpersec, "WHT")
		
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAL("xpersec*3600 = xperhour", "GLD")
		Glance.Functions.TTAL(var.xpersec.."*3600 = "..var.xperhour, "WHT")
		
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAL("neededxp/xpersec = leveltime", "GLD")
		Glance.Functions.TTAL(var.needed.."/"..var.xpersec.." = "..var.leveltime, "WHT")
	end
	
	if var.petcap ~= 0 then
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAD("Hunter Pet (Level)", "XP", "GLD", "GLD")
		Glance.Functions.TTAD(UnitName("pet").." (|cff00ff00"..var.petlevel.."|r) ", var.petcurrent.."/"..var.petcap.." ("..var.petcurrentPCT.."%)","WHT", "GRN")
	end
	
	if pty.a.level ~= 0 then
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAD("Party (Level) (Level%)", "XP/Hour", "GLD", "GLD")
		Glance.Functions.TTAD(pty.a.name.." (|cff00ff00"..pty.a.level.."|r) (|cff00ff00"..pty.a.xpercent.."%|r)", pty.a.xperhour, "WHT", "GRN")
		if pty.b.level ~= 0 then
			Glance.Functions.TTAD(pty.b.name.." (|cff00ff00"..pty.b.level.."|r) (|cff00ff00"..pty.b.xpercent.."%|r)", pty.b.xperhour, "WHT", "GRN")
		end
		if pty.c.level ~= 0 then
			Glance.Functions.TTAD(pty.c.name.." (|cff00ff00"..pty.c.level.."|r) (|cff00ff00"..pty.c.xpercent.."%|r)", pty.c.xperhour, "WHT", "GRN")
		end
		if pty.d.level ~= 0 then
			Glance.Functions.TTAD(pty.d.name.." (|cff00ff00"..pty.d.level.."|r) (|cff00ff00"..pty.d.xpercent.."%|r)", pty.d.xperhour, "WHT", "GRN")
		end
	end
end

---------------------------
-- Rep tooltip
---------------------------
function Glance.Functions.setTTRep()
	Glance.Functions.TTST("Reputation", "GLD")
	local hasWatch = false
	for i=1,GetNumFactions() do
		local name,_,_,bottomValue,topValue,earnedValue,_,_,isHeader,_,_,isWatched,_ = GetFactionInfo(i)
		if isWatched then
			hasWatch = true
			Glance.Functions.TTAD("Currently tracking "..Glance.Arrays.colors[Glance.Arrays.rep[""..topValue]]..name.."|r reputation:", Glance.Arrays.colors[Glance.Arrays.rep[""..topValue]]..Glance.Arrays.rep[""..topValue], "WHT", "WHT")
		end
	end
	if not hasWatch then
		Glance.Functions.TTAL("You are not tracking any reputation.", "WHT")
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("(Click to change Reputation tracking.)","WHT")
end

---------------------------
-- Professions tooltip
---------------------------
function Glance.Functions.setTTProfessions()
	Glance.Functions.updateProfessions()
	Glance.Functions.TTST("Professions", "GLD")
	local herb,mine = "",""
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	local Professions = {
		[1] = prof1,
		[2] = prof2,
		[3] = archaeology,
		[4] = fishing,
		[5] = cooking,
		[6] = firstAid
	}
	for i=1,6 do
		if Professions[i] ~= nil then
			local pLevel = ""
			local name, icon, skillLevel, maxSkillLevel,_,_,_,_ = GetProfessionInfo(Professions[i])
			if Glance.Arrays.Professions[""..maxSkillLevel] ~= nil then
				pLevel = Glance.Arrays.Professions[""..maxSkillLevel]
			end
			--Glance.Functions.TTAD("|T"..icon..":0|t "..name..": |cFF69CCF0("..pLevel..")", skillLevel.."/"..maxSkillLevel, "WHT","GRN")
			Glance.Functions.TTAD(name..": |cFF69CCF0("..pLevel..")", skillLevel.."/"..maxSkillLevel, "WHT","GRN")
			if name=="Mining" and skillLevel < 525 then
				for i=#Glance.Data.Mining,1,-1 do
					ore, lvl, loc = unpack(Glance.Data.Mining[i])
					if skillLevel >= lvl then mine = "You should be mining |cffff5500"..ore.."|r in: |cffffff00"..loc break end
				end
			end
			if name=="Herbalism" and skillLevel < 525 then
				for i=#Glance.Data.Herbalism,1,-1 do
					ore, lvl, loc = unpack(Glance.Data.Herbalism[i])
					if skillLevel >= lvl then herb = "You should be gathering |cffff5500"..ore.."|r in: |cffffff00"..loc break end
				end
			end
		end
	end
	if mine ~= "" then
		Glance.Functions.TTAL(" ","GLD")
		Glance.Functions.TTAL("Mining","GLD")
		Glance.Functions.TTALW(mine,"WHT")
	end
	if herb ~= "" then
		Glance.Functions.TTAL(" ","GLD")
		Glance.Functions.TTAL("Herbalism","GLD")
		Glance.Functions.TTALW(herb,"WHT")
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("(Click to change Profession tracking.)","WHT")
end

---------------------------
-- Latency/framerate tooltip
---------------------------
function Glance.Functions.setTTLAG()
	local bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
	Glance.Functions.TTST("Latency", "GLD")
	Glance.Functions.TTAD("Home", Glance.Functions.formatLag(latencyHome).." ms","WHT","GRN")
	Glance.Functions.TTAD("World", Glance.Functions.formatLag(latencyWorld).." ms","WHT","GRN")
	Glance.Functions.TTAD("Upload", Glance.Functions.formatBandwidth(bandwidthOut),"WHT","GRN")
	Glance.Functions.TTAD("Download", Glance.Functions.formatBandwidth(bandwidthIn),"WHT","GRN")
	
	local pty = Glance.Variables.party
	if pty.a.level ~= 0 then
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAL("Party", "GLD")
		Glance.Functions.TTAD(pty.a.name, Glance.Functions.formatLag(tonumber(pty.a.lag)), "WHT", "GRN")
		if pty.b.level ~= 0 then
			Glance.Functions.TTAD(pty.b.name, Glance.Functions.formatLag(tonumber(pty.b.lag)), "WHT", "GRN")
		end
		if pty.c.level ~= 0 then
			Glance.Functions.TTAD(pty.c.name, Glance.Functions.formatLag(tonumber(pty.c.lag)), "WHT", "GRN")
		end
		if pty.d.level ~= 0 then
			Glance.Functions.TTAD(pty.dd.name, Glance.Functions.formatLag(tonumber(pty.d.lag)), "WHT", "GRN")
		end
	end
end

---------------------------
-- Latency/framerate tooltip
---------------------------
function Glance.Functions.setTTFPS()
	Glance.Functions.TTST("Frames Per Second", "GLD")
	Glance.Functions.TTAD("Current", Glance.Functions.formatFPS(Glance.Variables.fps.current),"WHT","GRN")
	Glance.Functions.TTAD("Minimum", Glance.Functions.formatFPS(Glance.Variables.fps.min),"WHT","GRN")
	Glance.Functions.TTAD("Maximum", Glance.Functions.formatFPS(Glance.Variables.fps.max),"WHT","GRN")
	Glance.Functions.TTAD("Average", Glance.Functions.formatFPS(Glance.Variables.fps.avg),"WHT","GRN")
	
	local pty = Glance.Variables.party
	if pty.a.level ~= 0 then
		Glance.Functions.TTAL(" ", "WHT")
		Glance.Functions.TTAL("Party", "GLD")
		Glance.Functions.TTAD(pty.a.name, Glance.Functions.formatFPS(pty.a.fps), "WHT", "GRN")
		if pty.b.level ~= 0 then
			Glance.Functions.TTAD(pty.b.name, Glance.Functions.formatFPS(pty.b.fps), "WHT", "GRN")
		end
		if pty.c.level ~= 0 then
			Glance.Functions.TTAD(pty.c.name, Glance.Functions.formatFPS(pty.c.fps), "WHT", "GRN")
		end
		if pty.d.level ~= 0 then
			Glance.Functions.TTAD(pty.d.name, Glance.Functions.formatFPS(pty.d.fps), "WHT", "GRN")
		end
	end
end

---------------------------
-- memory tooltip
---------------------------
function Glance.Functions.setTTMem()
	Glance.Functions.updateMem()
	local k,v,i
	local resort = false
	for i=1, #Glance.Arrays.addons do
		if Glance.Variables.TimeSinceLastMemUpdate <= 1 then
			mem = GetAddOnMemoryUsage(Glance.Arrays.addons[i][1])
			if Glance.Arrays.addons[i][2] ~= mem then
				if Glance.Arrays.addons[i][2] > mem then
					Glance.Arrays.addons[i][4] = "down"
				elseif Glance.Arrays.addons[i][2] < mem then
					Glance.Arrays.addons[i][4] = "up"
				end
				Glance.Arrays.addons[i][3] = "GRN"
				Glance.Arrays.addons[i][2] = mem
				resort = true
			else 
				Glance.Arrays.addons[i][3] = "LBL"
				Glance.Arrays.addons[i][4] = "steady"
			end
		else
			Glance.Arrays.addons[i][3] = "LBL"
			Glance.Arrays.addons[i][4] = "steady"
		end
	end
	if Glance.Variables.TimeSinceLastMemUpdate <= 1 then
		table.sort(Glance.Arrays.addons, function(a, b) return a[2] > b[2] end)
	end
	Glance.Functions.TTST("Memory Usage", "GLD")
	for k, v in pairs(Glance.Arrays.addons) do
		if v[2] > 1000 then
			Glance.Functions.TTAD("|T".."Interface\\Addons\\Glance\\images\\"..v[4]..":0|t "..format("%s", v[1]), Glance.Functions.FormatMemory(v[2]), v[3], "RED")
		elseif v[2] > 500 then
			Glance.Functions.TTAD("|T".."Interface\\Addons\\Glance\\images\\"..v[4]..":0|t "..format("%s", v[1]), Glance.Functions.FormatMemory(v[2]), v[3], "YEL")
		else
			Glance.Functions.TTAD("|T".."Interface\\Addons\\Glance\\images\\"..v[4]..":0|t "..format("%s", v[1]), Glance.Functions.FormatMemory(v[2]), v[3], "GRN")
		end
	end
	Glance.Functions.TTAL(" ","WHT")
	Glance.Functions.TTAD("Total Memory Usage: ", Glance.Functions.FormatMemory(Glance.Variables.memory), "WHT","WHT")
	Glance.Functions.TTAL(" ","WHT")
	Glance.Functions.TTAL("(Click to force garbage collection)","WHT")
end

---------------------------
-- Mounts tooltip
---------------------------
function Glance.Functions.setTTMounts()
	Glance.Functions.TTST("Mounts", "GLD")
	Glance.Functions.TTALW("Click 'Mounts' to show a dropdown menu of available mounts for your skill and location. Select one to mount or dismount.","WHT")
end

---------------------------
-- Pets tooltip
---------------------------
function Glance.Functions.setTTPets()
	Glance.Functions.TTST("Pets", "GLD")
	Glance.Functions.TTALW("Click 'Pets' to show a dropdown menu of available companion pets for you to select and summon.","WHT")
end

---------------------------
-- clock tooltip
---------------------------
function Glance.Functions.setTTTime()
	local hour, min = GetGameTime()
	local lhour = tonumber(date("%H"))
	Glance.Functions.TTST("Clock", "GLD")
	Glance.Functions.TTAD("Server Time: ", Glance.Functions.GetHour(hour)..":"..Glance.Functions.GetMin(min).." "..Glance.Functions.GetDST(hour), "WHT","GRN")
	Glance.Functions.TTAD("Local Time: ", Glance.Functions.GetHour(lhour)..":"..Glance.Functions.GetMin(min).." "..Glance.Functions.GetDST(lhour), "WHT","GRN")
	Glance.Functions.TTAD("Date: ", date("%m/%d/%y"), "WHT","GRN")
	Glance.Functions.TTAL(" ","WHT")
	Glance.Functions.TTAL("(Click to open the calendar)","WHT")
end

---------------------------
-- Wintergrasp tooltip
---------------------------
function Glance.Functions.setTTWG()
	Glance.Functions.TTST("Wintergrasp", "GLD")
	SetMapToCurrentZone()
	local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(1)
	--local sec = GetWintergraspWaitTime()
	local control = "|r"
	SetMapByID(485) --708 for tol barad
	for i = 1, GetNumMapLandmarks() do
		local index = select(3, GetMapLandmarkInfo(i))
		if index == 46 then
			control = "|cFF69CCF0Alliance"
		elseif index == 48 then
			control = "|cFFC41F3BHorde"
		end
	end
	if not isActive then
		if (control=="|r") then
			Glance.Functions.TTAL("|rControl of "..localizedName.." cannot be determined.", "WHT")
			Glance.Functions.TTAL("|rYou must be in Northrend at least once this session.", "WHT")
		else
			Glance.Functions.TTAL("|r"..localizedName.." is in "..control.." |rcontrol.", "WHT")
		end
	else
		Glance.Functions.TTAL("|rThe battle for Lake "..localizedName.." is in progress.", "WHT")
	end
end

---------------------------
-- Tol Barad tooltip
---------------------------
function Glance.Functions.setTTTB()
	Glance.Functions.TTST("Tol Barad", "GLD")
	SetMapToCurrentZone()
	local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(2)
	local control = "|r"
	SetMapByID(708) 
	for i = 1, GetNumMapLandmarks() do
		local index = select(3, GetMapLandmarkInfo(i))
		if index == 46 then
			control = "|cFF69CCF0Alliance"
		elseif index == 48 then
			control = "|cFFC41F3BHorde"
		end
	end
	if not isActive then
		if (control=="|r") then
			Glance.Functions.TTAL("|rControl of "..localizedName.." cannot be determined.", "WHT")
			Glance.Functions.TTAL("|rYou must be in Tol Barad at least once this session.", "WHT")
		else
			Glance.Functions.TTAL("|r"..localizedName.." is in "..control.." |rcontrol.", "WHT")
		end
	else
		Glance.Functions.TTAL("|rThe battle for "..localizedName.." is in progress.", "WHT")
	end
end